// The Sky_Factory 
// version 1.1
// POV Version: 3.6
// Made by  Leroy Whetstone Email lrwii@joplin.com

#ifndef(Get)//if called from another File don't do this

//========= Changes ====================================================

 // Files Saves/loads include
 //  an empty string means don't do
 #declare SaveData="";//place Name of file, like data.inc
 #declare SaveSky="";//place Name of file, like data.pov
 #declare AddtoSky=no;//append to SaveSky an POV file
 #declare LoadFile="";//place Name of file, uses #include

 //boxes
 #declare BoxL=<-250005,-505,-95>;//lowest corner middle box size
 #declare BoxH=<250005,505,20005>;//upper corner middle box size
 #declare BoxD=2;//difference between Middle and other boxes
 #declare Boxn=6;//boxes 1=Low,2=Mid,4=High,7=all place boxes 0=no boxes

 //background(sky_sphere)
 #declare BackPig=1;//0-11 background(sky_sphere) pigment map
                    //<6 gradient >5 cylindrical
 #declare BackRev=0;//reverse background pigment colors
 #declare BackRotate=<0,0,0>;//vector rotate background(sky_sphere) pigment 
 #declare BackMap=.3;//0-1 pigment color_map point
                     //try Smaller values for BackPig<6  
                     //try Larger values for BackPig>5 
 #declare BackTurb=<0,0,0>;//pigment map turbulence value
 #declare Back_Dc=<1,1,1>;// darken color of background sky 1=normal

 //Clouds Type & pigment blend maps variables
 //Low Cloud box value 1
 #declare CloudLn=1;//0-5 Low clouds near viewer 
 #declare CloudLf=2;//0-5 Low clouds far from viewer 
  #declare CloudLn_Dc=<1,1,1>;// darken Ln Clouds 1=normal
  #declare CloudLf_Dc=<1,1,1>;// darken Lf Clouds 1=normal
   #declare CloudLn_Ps=<500,800,550>;  // scale Ln Clouds pigment
   #declare CloudLf_Ps=<2000,2500,2000>;// scale Lf Clouds pigment
  #declare CloudL_Mv=<0,0,0>;    //move(translate) Ln & Lf Clouds pigments
  #declare CloudL_Rot=<0,0,0>;//Rotate Low box Clouds pigments
  #declare CloudL_Range=<.1,.5>; // Near/Far color_map transition values x= closest 
  #declare CloudL_Turb=<0,0,0>; //Low box color_map turbulence value
  #declare CloudL_Amb=<.8,.8,.8>; //Low box ambient
  #declare CloudL_Shadow=yes;      //yes/no cast shadows
  
 //Mid Cloud box value 2
 #declare CloudMn=2;//0-5 Mid clouds near viewer 
 #declare CloudMf=3;//0-5 Mid clouds far from viewer 
  #declare CloudMn_Dc=<1,1,1>; //darken Clouds 1=normal
  #declare CloudMf_Dc=<1,1,1>; //darken Clouds 1=normal
   #declare CloudMn_Ps=<500,800,550>;  // scale Mn Clouds pigment
   #declare CloudMf_Ps=<2000,2500,2000>;// scale Mf Clouds pigment
  #declare CloudM_Mv=<0,0,0>;    //move(translate) Mn & Mf Cloud pigments
  #declare CloudM_Rot=<0,0,0>;//Rotate Mid Box Clouds pigments
  #declare CloudM_Range=<.1,.5>; //Far/Near color_map transition values x= closest 
  #declare CloudM_Turb=<0,0,0>;  //Mid box color_map turbulence value
  #declare CloudM_Amb=<.9,.9,.9>; //Mid box ambient
  #declare CloudM_Shadow=no;     //yes/no cast shadows

 //High Cloud box value 4
 #declare CloudHn=5;  //0-5 high clouds near viewer 
 #declare CloudHf=1;  //0-5 high clouds far from viewer 
  #declare CloudHn_Dc=<1,1,1>;    //darken Hn Clouds 1=normal
  #declare CloudHf_Dc=<1,1,1>;    //darken HF Clouds 1=normal
   #declare CloudHn_Ps=<500,800,550>;      // scale Hn Clouds pigment
   #declare CloudHf_Ps=<2000,2500,2000>; // scale Hf Clouds pigment
  #declare CloudH_Mv=<0,0,0>;   // move(translate) Hn & Hf  Clouds pigments
  #declare CloudH_Rot=<0,0,0>;  //Rotate high box Clouds pigments
  #declare CloudH_Range=<.1,.5>;//Far/Near color_map transition values x= closest 
  #declare CloudH_Turb=<0,0,0>; //high box color_map turbulence value
  #declare CloudH_Amb=<1,1,1>;  //high box ambient
  #declare CloudH_Shadow=no;    //yes/no high box cast shadows
 
 #end

//=======end of changes=================================================

#macro Bit(a,b) //no.,bit return 0 or 1
 #local c= int(a/pow(2,b));
 select(mod(c, 2), 1, 0, 1)
#end
#macro BitSet(a,b)//no.,bit. returns int in A 
  #if(!Bit(a,b))
   #local d=pow(2,b);
   #declare a=a+d;
  #end
#end    
#macro Vequ(a,b)//vec,vec return 1-equal 0-not equal
  #local Ret=0;
  #if((a.x=b.x)&(a.y=b.y)&(a.z=b.z)) #local Ret=1; #end
  Ret
#end    
#macro V3Limit(a)//vec returns vect with fraction limit of 5 places
    #local c1=int(a.x*100000)/100000;
    #local c2=int(a.y*100000)/100000;
    #local c3=int(a.z*100000)/100000;
    <c1,c2,c3>
#end

#ifndef (SaveData)#declare SaveData="";#end
#ifndef (SaveSky) #declare SaveSky="";#end
#ifndef (AddtoSky) #declare AddtoSky=no;#end
#ifndef (LoadFile) #declare LoadFile="";#end

// load data
 #if(strlen(LoadFile)) 
  #include LoadFile 
  #debug concat("\n  Loaded  ",LoadFile,"\n\n")
 #end

//save data
#if(strlen(SaveData))
  #debug concat("\n  Saved Data as ",SaveData,"\n\n")
 #fopen Mfile SaveData write 
 //boxes
 #write (Mfile "//___LR Sky Data___\n\n")
 #write (Mfile "//boxes\n")
 #write (Mfile "#declare BoxL=",BoxL,";\n")
 #write (Mfile "#declare BoxH=",BoxH,";\n")
 #write (Mfile "#declare BoxD=",BoxD,";\n")
 #write (Mfile "#declare Boxn=",Boxn,";\n\n")
 //background
 #write (Mfile "//background\n")
 #write (Mfile "#declare BackPig=",BackPig,";\n")
 #write (Mfile "#declare BackRev=",BackRev,";\n")
 #write (Mfile "#declare BackRotate=",BackRotate,";\n")
 #write (Mfile "#declare BackMap=",BackMap,";\n")
 #write (Mfile "#declare Back_Dc=",Back_Dc,";\n\n")
 //Cloud pigment blend maps
 #write (Mfile "//Clouds\n")
 //Clouds Type
 #write (Mfile "//Clouds for Lower box\n")
 #write (Mfile "#declare CloudLn=",CloudLn,";\n")
 #write (Mfile "#declare CloudLf=",CloudLf,";\n")
  #write (Mfile " #declare CloudLn_Dc=",CloudLn_Dc,";\n")
  #write (Mfile " #declare CloudLf_Dc=",CloudLf_Dc,";\n")
  #write (Mfile " #declare CloudLn_Ps=",CloudLn_Ps,";\n")
  #write (Mfile " #declare CloudLf_Ps=",CloudLf_Ps,";\n")
  #write (Mfile "  #declare CloudL_Mv=",CloudL_Mv,";\n")
  #write (Mfile "  #declare CloudL_Rot=",CloudL_Rot,";\n")
  #write (Mfile "  #declare CloudL_Range=",CloudL_Range,";\n")
  #write (Mfile "  #declare CloudL_Turb=",CloudL_Turb,";\n")
  #write (Mfile "  #declare CloudL_Amb=",CloudL_Amb,";\n")
  #write (Mfile "  #declare CloudL_Shadow=",CloudL_Shadow,";\n\n")
    
  #write (Mfile "//Clouds for Middle box\n")
 #write (Mfile "#declare CloudMn=",CloudMn,";\n")
 #write (Mfile "#declare CloudMf=",CloudMf,";\n")
  #write (Mfile " #declare CloudMn_Dc=",CloudMn_Dc,";\n")
  #write (Mfile " #declare CloudMf_Dc=",CloudMf_Dc,";\n")
  #write (Mfile " #declare CloudMn_Ps=",CloudMn_Ps,";\n")
  #write (Mfile " #declare CloudMf_Ps=",CloudMf_Ps,";\n")
  #write (Mfile "  #declare CloudM_Mv=",CloudM_Mv,";\n")
  #write (Mfile "  #declare CloudM_Rot=",CloudM_Rot,";\n")
  #write (Mfile "  #declare CloudM_Range=",CloudM_Range,";\n")
  #write (Mfile "  #declare CloudM_Turb=",CloudM_Turb,";\n")
  #write (Mfile "  #declare CloudM_Amb=",CloudM_Amb,";\n")
  #write (Mfile "  #declare CloudM_Shadow=",CloudM_Shadow,";\n\n")

 #write (Mfile "//Clouds for Higher box\n")
 #write (Mfile "#declare CloudHn=",CloudHn,";\n")
 #write (Mfile "#declare CloudHf=",CloudHf,";\n")
  #write (Mfile " #declare CloudHn_Dc=",CloudHn_Dc,";\n")
  #write (Mfile " #declare CloudHf_Dc=",CloudHf_Dc,";\n")
  #write (Mfile " #declare CloudHn_Ps=",CloudHn_Ps,";\n")
  #write (Mfile " #declare CloudHf_Ps=",CloudHf_Ps,";\n")
  #write (Mfile "  #declare CloudH_Mv=",CloudH_Mv,";\n")
  #write (Mfile "  #declare CloudH_Rot=",CloudH_Rot,";\n")
  #write (Mfile "  #declare CloudH_Range=",CloudH_Range,";\n")
  #write (Mfile "  #declare CloudH_Turb=",CloudH_Turb,";\n")
  #write (Mfile "  #declare CloudH_Amb=",CloudH_Amb,";\n")
  #write (Mfile "  #declare CloudH_Shadow=",CloudH_Shadow,";\n\n")
 #fclose Mfile
#end
//make sky
#if (BoxD<0) #declare BoxD=abs(BoxD); #end
#declare HBoxL=BoxL-BoxD;//larger box
#declare HBoxH=BoxH+BoxD;
              
#declare LBoxL=BoxL+BoxD;//smaller box
#declare LBoxH=BoxH-BoxD;

#declare Zscal=BoxH.z+.01;//pigment scale

#if((Boxn<0)|(Boxn>7)) #declare Boxn=0; #end //boxes fix if out of range

#macro Cloud_Select(Type,Nam,Color,Mov,Rots)
 #switch(Type)
 #case(1)Write_Cloud1(Nam,Color,Mov,Rots)#break
 #case(2)Write_Cloud2(Nam,Color,Mov,Rots)#break
 #case(3)Write_Cloud3(Nam,Color,Mov,Rots)#break
 #case(4)Write_Cloud4(Nam,Color,Mov,Rots)#break
 #case(5)Write_Cloud5(Nam,Color,Mov,Rots)#break
 #else
 #case(5)Write_Cloud0(Nam)#break
 #end 
#end 

#macro P_Cloud0() pigment {rgbt 1}#end 
#macro Write_Cloud0(Name) 
   #write (Mfile "#declare P_Cloud",Name," = pigment{rgbt 1}\n")
#end

#macro P_Cloud1(Dark,Trans,Rot) 
 #local Dct=Dark*<1,1,1>;
 #local DcF=<1,1,1,1>;//Dark*<1,1,1>+<0,0,0,1>;
 pigment {
    bozo
    turbulence 0.65
    octaves 6
    omega 0.7
    lambda 2
    color_map {
        [0.0, rgb<.85,0.85,0.85>*Dct]
        [0.1,  rgb .75*Dct]
        [0.5,  rgbt DcF]
    }
    scale <6, 1, 6>
    translate Trans
    rotate Rot 
 }
#end
#macro Write_Cloud1(Name,Dark,Trans,Rot) 
 #local Dct=Dark*<1,1,1>;
 #local DcF=<1,1,1,1>;//Dark*<1,1,1>+<0,0,0,1>;
   #write (Mfile "#declare P_Cloud",Name,"=\n")
   #write (Mfile "   pigment {\n")
   #write (Mfile "    bozo\n")
   #write (Mfile "    turbulence 0.65\n")
   #write (Mfile "    octaves 6\n")
   #write (Mfile "    omega 0.7\n")
   #write (Mfile "    lambda 2\n")
   #write (Mfile "    color_map {\n")
   #write (Mfile "        [0.0 rgb"<.85,0.85,0.85>*Dct,"]\n")
   #write (Mfile "        [0.1 rgb".75*Dct,"]\n")
   #write (Mfile "        [0.5 rgbt",DcF,"]\n")
   #write (Mfile "   }\n")
   #write (Mfile "    scale <6, 1, 6>\n")
   #if(vlength(Trans)) #write (Mfile "    translate",Trans,"\n") #end
   #if(vlength(Rot))   #write (Mfile "    rotate ",Rot ,"\n") #end
   #write (Mfile "   }\n")
#end

#macro P_Cloud2(Dark,Trans,Rot) 
 #local Dct=Dark*<1,1,1>;
 #local DcF=<1,1,1,1>;//Dark*<1,1,1>+<0,0,0,1>;
 pigment {
    wrinkles
    turbulence 0.65
    octaves 6
    omega 0.7
    lambda 2
    color_map {
        [0, rgbt DcF]
        [0.1, rgb .75*Dct]
        [0.5, rgbt DcF]
    }
    scale <6, 1, 6>
    translate Trans 
    rotate Rot
 }
#end
#macro Write_Cloud2(Name,Dark,Trans,Rot) 
 #local Dct=Dark*<1,1,1>;
 #local DcF=<1,1,1,1>;//Dark*<1,1,1>+<0,0,0,1>;
   #write (Mfile "#declare P_Cloud",Name," =\n")
   #write (Mfile "   pigment {\n")
   #write (Mfile "    wrinkles\n")
   #write (Mfile "    turbulence 0.65\n")
   #write (Mfile "    octaves 6\n")
   #write (Mfile "    omega 0.7\n")
   #write (Mfile "    lambda 2\n")
   #write (Mfile "    color_map {\n")
   #write (Mfile "        [0   rgbt ",DcF,"]\n")
   #write (Mfile "        [0.1 rgb",.75*Dct,"]\n")
   #write (Mfile "        [0.5 rgbt",DcF,"]\n")
   #write (Mfile "   }\n")
   #write (Mfile "    scale <6, 1, 6>\n")
   #if(vlength(Trans))#write (Mfile "    translate",Trans,"\n")#end
   #if(vlength(Rot))  #write (Mfile "    rotate ",Rot ,"\n") #end
   #write (Mfile "   }\n")
#end

#macro P_Cloud3(Dark,Trans,Rot) 
 #local Dct=Dark*<1,1,1>;
 #local DcF=<1,1,1,1>;//Dark*<1,1,1>+<0,0,0,1>;
 pigment {
    granite
    color_map {
        [.6  rgbt DcF]
        [.8  rgb 1*Dct]
        [.9  rgb .8*Dct]
    }
  scale <16, 2, 6>
  translate Trans
  rotate Rot
 }
#end
#macro Write_Cloud3(Name,Dark,Trans,Rot) 
 #local Dct=Dark*<1,1,1>;
 #local DcF=<1,1,1,1>;//Dark*<1,1,1>+<0,0,0,1>;
   #write (Mfile "#declare P_Cloud",Name," =\n")
   #write (Mfile "   pigment {\n")
   #write (Mfile "    granite\n")
   #write (Mfile "    color_map {\n")
   #write (Mfile "        [0.6 rgbt",DcF,"]\n")
   #write (Mfile "        [0.8 rgb",Dct,"]\n")
   #write (Mfile "        [0.9 rgb",.8*Dct,"]\n")
   #write (Mfile "   }\n")
   #write (Mfile "    scale <16, 2, 6>\n")
   #if(vlength(Trans))#write (Mfile "    translate",Trans,"\n")#end
   #if(vlength(Rot))  #write (Mfile "    rotate ",Rot ,"\n") #end
   #write (Mfile "   }\n")
#end

#macro P_Cloud4(Dark,Trans,Rot) 
 #local Dct=Dark*<1,1,1>;
 #local DcF=<1,1,1,1>;//Dark*<1,1,1>+<0,0,0,1>;
 pigment {
    wrinkles
    turbulence 0.1
    lambda 2.2
    omega 0.707
    color_map {
        [0.50 rgbt DcF ]
        [0.8 rgb<0.8,0.8,0.8>*Dct]
        [1 rgb<0.7,0.7,0.7>*Dct]
    }
    scale <0.5, 0.15, 1>
   translate Trans
   rotate Rot
 }
#end
#macro Write_Cloud4(Name,Dark,Trans,Rot) 
 #local Dct=Dark*<1,1,1>;
 #local DcF=<1,1,1,1>;//Dark*<1,1,1>+<0,0,0,1>;
   #write (Mfile "#declare P_Cloud",Name," =\n")
   #write (Mfile "   pigment {\n")
   #write (Mfile "    wrinkles\n")
   #write (Mfile "    turbulence 0.1\n")
   #write (Mfile "    omega 0.707\n")
   #write (Mfile "    lambda 2.2\n")
   #write (Mfile "    color_map {\n")
   #write (Mfile "        [0.5 rgbt ",DcF,"]\n")
   #write (Mfile "        [0.8 rgb",<0.8,0.8,0.8>*Dct,"]\n")
   #write (Mfile "        [1   rgb",<0.7,0.7,0.7>*Dct,"]\n")
   #write (Mfile "   }\n")
   #write (Mfile "    scale <0.5, 0.15, 1>\n")
   #if(vlength(Trans))#write (Mfile "    translate",Trans,"\n")#end
   #if(vlength(Rot))  #write (Mfile "    rotate ",Rot ,"\n") #end
   #write (Mfile "   }\n")
#end
#macro P_Cloud5(Dark,Trans,Rot) 
 #local Dct=Dark*<1,1,1>;
 #local DcF=<1,1,1,1>;//Dark*<1,1,1>+<0,0,0,1>;
 pigment {
    ripples//bozo
    color_map {
        [.4  rgbt DcF]
        [.47 rgb<0.6941,0.6941,0.7196>*Dct]
        [.7  rgb<0.4941,0.4941,0.5196>*Dct]
        [.8  rgbt DcF]
    }
    turbulence <.65,.7,.5>
    octaves 6
    omega 0.707
    lambda 3
    scale <8, 4, 8>
   translate Trans
   rotate Rot
 }
#end
#macro Write_Cloud5(Name,Dark,Trans,Rot) 
 #local Dct=Dark*<1,1,1>;
 #local DcF=<1,1,1,1>;//Dark*<1,1,1>+<0,0,0,1>;
   #write (Mfile "#declare P_Cloud",Name," =\n")
   #write (Mfile "   pigment {\n")
   #write (Mfile "    ripples\n")
   #write (Mfile "    turbulence<.65,.7,.5>\n")
   #write (Mfile "    octaves 6\n")
   #write (Mfile "    omega 0.707\n")
   #write (Mfile "    lambda 3\n")
   #write (Mfile "    color_map {\n")
   #write (Mfile "        [.4  rgbt ",DcF,"]\n")
   #write (Mfile "        [.47 rgb",<0.6941,0.6941,0.7196>*Dct,"]\n")
   #write (Mfile "        [.7  rgb",<0.4941,0.4941,0.5196>*Dct,"]\n")
   #write (Mfile "        [.8  rgbt",DcF,"]\n")
   #write (Mfile "   }\n")
   #write (Mfile "    scale <8, 4, 8>\n")
   #if(vlength(Trans))#write (Mfile "    translate",Trans,"\n")#end
   #if(vlength(Rot))  #write (Mfile "    rotate ",Rot ,"\n") #end
   #write (Mfile "   }\n")
#end
#if((CloudLn<0)|(CloudLn>5)) #declare CloudLn=0; #end
#switch(CloudLn)
 #declare CL1n="P_CloudLn" #declare CL1p="Ln" 
 #case(1) #declare CL1=P_Cloud1(CloudLn_Dc,CloudL_Mv,CloudL_Rot)#break
 #case(2) #declare CL1=P_Cloud2(CloudLn_Dc,CloudL_Mv,CloudL_Rot)#break
 #case(3) #declare CL1=P_Cloud3(CloudLn_Dc,CloudL_Mv,CloudL_Rot)#break
 #case(4) #declare CL1=P_Cloud4(CloudLn_Dc,CloudL_Mv,CloudL_Rot)#break
 #case(5) #declare CL1=P_Cloud5(CloudLn_Dc,CloudL_Mv,CloudL_Rot)#break
 #else    #declare CL1=P_Cloud0()
#end
#if((CloudLf<0)|(CloudLf>5)) #declare CloudLf=0; #end
#switch(CloudLf)
 #declare CL2n="P_CloudLf" #declare CL2p="Lf" 
 #case(1) #declare CL2=P_Cloud1(CloudLf_Dc,CloudL_Mv,CloudL_Rot)#break
 #case(2) #declare CL2=P_Cloud2(CloudLf_Dc,CloudL_Mv,CloudL_Rot)#break
 #case(3) #declare CL2=P_Cloud3(CloudLf_Dc,CloudL_Mv,CloudL_Rot)#break
 #case(4) #declare CL2=P_Cloud4(CloudLf_Dc,CloudL_Mv,CloudL_Rot)#break
 #case(5) #declare CL2=P_Cloud5(CloudLf_Dc,CloudL_Mv,CloudL_Rot)#break
 #else    #declare CL2=P_Cloud0()
#end
#if((CloudMn<0)|(CloudMn>5)) #declare CloudMn=0; #end
#switch(CloudMn)
  #declare CM1n="P_CloudMn" #declare CM1p="Mn" 
 #case(1) #declare CM1=P_Cloud1(CloudMn_Dc,CloudM_Mv,CloudM_Rot)#break
 #case(2) #declare CM1=P_Cloud2(CloudMn_Dc,CloudM_Mv,CloudM_Rot)#break
 #case(3) #declare CM1=P_Cloud3(CloudMn_Dc,CloudM_Mv,CloudM_Rot)#break
 #case(4) #declare CM1=P_Cloud4(CloudMn_Dc,CloudM_Mv,CloudM_Rot)#break
 #case(5) #declare CM1=P_Cloud5(CloudMn_Dc,CloudM_Mv,CloudM_Rot)#break
 #else    #declare CM1=P_Cloud0()
#end
#if((CloudMf<0)|(CloudMf>5)) #declare CloudMf=0; #end
#switch(CloudMf)
 #declare CM2n="P_CloudMf" #declare CM2p="Mf" 
 #case(1) #declare CM2=P_Cloud1(CloudMf_Dc,CloudM_Mv,CloudM_Rot)#break
 #case(2) #declare CM2=P_Cloud2(CloudMf_Dc,CloudM_Mv,CloudM_Rot)#break
 #case(3) #declare CM2=P_Cloud3(CloudMf_Dc,CloudM_Mv,CloudM_Rot)#break
 #case(4) #declare CM2=P_Cloud4(CloudMf_Dc,CloudM_Mv,CloudM_Rot)#break
 #case(5) #declare CM2=P_Cloud5(CloudMf_Dc,CloudM_Mv,CloudM_Rot)#break
 #else    #declare CM2=P_Cloud0()
#end
#if((CloudHn<0)|(CloudHn>5)) #declare CloudHn=0; #end
#switch(CloudHn)
 #declare CH1n="P_CloudHn" #declare CH1p="Hn" 
 #case(1) #declare CH1=P_Cloud1(CloudHn_Dc,CloudH_Mv,CloudH_Rot)#break
 #case(2) #declare CH1=P_Cloud2(CloudHn_Dc,CloudH_Mv,CloudH_Rot)#break
 #case(3) #declare CH1=P_Cloud3(CloudHn_Dc,CloudH_Mv,CloudH_Rot)#break
 #case(4) #declare CH1=P_Cloud4(CloudHn_Dc,CloudH_Mv,CloudH_Rot)#break
 #case(5) #declare CH1=P_Cloud5(CloudHn_Dc,CloudH_Mv,CloudH_Rot)#break
 #else    #declare CH1=P_Cloud0()
#end
#if((CloudMf<0)|(CloudMf>5)) #declare CloudMf=0; #end
#switch(CloudHf)
 #declare CH2n="P_CloudHf" #declare CH2p="Hf" 
 #case(1) #declare CH2=P_Cloud1(CloudHf_Dc,CloudH_Mv,CloudH_Rot)#break
 #case(2) #declare CH2=P_Cloud2(CloudHf_Dc,CloudH_Mv,CloudH_Rot)#break 
 #case(3) #declare CH2=P_Cloud3(CloudHf_Dc,CloudH_Mv,CloudH_Rot)#break 
 #case(4) #declare CH2=P_Cloud4(CloudHf_Dc,CloudH_Mv,CloudH_Rot)#break
 #case(5) #declare CH2=P_Cloud5(CloudHf_Dc,CloudH_Mv,CloudH_Rot)#break
 #else    #declare CH2=P_Cloud0()
#end


//background sky_spheres
#if((BackPig<0)|(BackPig>11)) #declare BackPig=0; #end
#switch(BackPig)
 #case(1) #declare Sky_Pigment=pigment{gradient y
       #if(BackRev)
        color_map{[0 rgb<0.1647,0.1980,0.7922>*Back_Dc][BackMap rgb<0.9196,0.9608,1.0000>*Back_Dc]}
       #else
        color_map{[0 rgb<0.9196,0.9608,1.0000>*Back_Dc][BackMap rgb<0.1647,0.1980,0.7922>*Back_Dc]}
       #end
       warp{repeat y flip y}
       warp{turbulence BackTurb}
       rotate BackRotate
      
       }
 #break
 #case(2) #declare Sky_Pigment=pigment{gradient y
       #if(BackRev)
        color_map{[0 rgb<0.1647,0.4980,0.7922>*Back_Dc][BackMap rgb<0.6196,0.9608,1.0000>*Back_Dc]}
       #else
        color_map{[0 rgb<0.6196,0.9608,1.0000>*Back_Dc][BackMap rgb<0.1647,0.4980,0.7922>*Back_Dc]}
       #end
       warp{repeat y flip y}
       warp{turbulence BackTurb}
       rotate BackRotate}
 #break
 #case(3) #declare Sky_Pigment=pigment{gradient y
       #if(BackRev)
        color_map{[0 rgb<0.5647,0.1980,0.6922>*Back_Dc][BackMap rgb<1,0.9008,1.0000>*Back_Dc]}
       #else
        color_map{[0 rgb<1,0.9008,1.0000>*Back_Dc][BackMap rgb<0.5647,0.1980,0.6922>*Back_Dc]}
       #end
       warp{repeat y flip y}
       warp{turbulence BackTurb}
       rotate BackRotate}
 #break
 #case(4)  #declare Sky_Pigment=pigment{gradient y
       #if(BackRev)
        color_map{[0 rgb<0.4627,0.5294,0.5961>*Back_Dc][BackMap rgb<0.6471,0.7137,0.7804>*Back_Dc]}
       #else
        color_map{[0 rgb<0.6471,0.7137,0.7804>*Back_Dc][BackMap rgb<0.4627,0.5294,0.5961>*Back_Dc]}
       #end
       warp{repeat y flip y}
       warp{turbulence BackTurb}
       rotate BackRotate}
 #break
 #case(5)  #declare Sky_Pigment=pigment{gradient y
       #if(BackRev)
        color_map{[0 rgb<0.8196,0.8196,0.6196>*Back_Dc][BackMap rgb<1.0000,1.0000,0.8863>*Back_Dc]}
       #else
        color_map{[0 rgb<1.0000,1.0000,0.8863>*Back_Dc][BackMap rgb<0.8196,0.8196,0.6196>*Back_Dc]}
       #end
       warp{repeat y flip y}
       warp{turbulence BackTurb}
       rotate BackRotate}
 #break
 #case(6) #declare Sky_Pigment=pigment{cylindrical
       #if(BackRev)
        color_map{[0 rgb<1,1,1>*Back_Dc][BackMap rgb<0,0,0>*Back_Dc]}
       #else
        color_map{[0 rgb <0,0,0>*Back_Dc][BackMap rgb<1.0000,1.0000,1>*Back_Dc]}
       #end
       scale.5
       rotate x*90
       warp{turbulence BackTurb}
       rotate BackRotate}
 #break           
 #case(7) #declare Sky_Pigment=pigment{cylindrical
       #if(BackRev)
        color_map{[0 rgb<0.9196,0.9608,1.0000>*Back_Dc][BackMap rgb<0.1647,0.1980,0.7922>*Back_Dc]}
       #else
        color_map{[0 rgb<0.1647,0.1980,0.7922>*Back_Dc][BackMap rgb<0.9196,0.9608,1.0000>*Back_Dc]}
       #end
       scale.5
       rotate x*90
       warp{turbulence BackTurb}
       rotate BackRotate}
 #break
 #case(8) #declare Sky_Pigment=pigment{cylindrical
       #if(BackRev)
        color_map{[0 rgb<0.6196,0.9608,1.0000>*Back_Dc][BackMap rgb<0.1647,0.4980,0.7922>*Back_Dc]}
       #else
        color_map{[0 rgb<0.1647,0.4980,0.7922>*Back_Dc][BackMap rgb<0.6196,0.9608,1.0000>*Back_Dc]}
       #end
       scale.5
       rotate x*90
       warp{turbulence BackTurb}
       rotate BackRotate}
 #break
 #case(9) #declare Sky_Pigment=pigment{cylindrical
       #if(BackRev)
        color_map{[0 rgb<1,0.9008,1.0000>*Back_Dc][BackMap rgb<0.5647,0.1980,0.6922>*Back_Dc]}
       #else
        color_map{[0 rgb<0.5647,0.1980,0.6922>*Back_Dc][BackMap rgb<1,0.9008,1.0000>*Back_Dc]}
       #end
       scale.5
       rotate x*90
       warp{turbulence BackTurb}
       rotate BackRotate}
 #break
 #case(10)  #declare Sky_Pigment=pigment{cylindrical
       #if(BackRev)     
        color_map{[0 rgb <0.8471,0.9137,0.9804>*Back_Dc][BackMap rgb<0.4627,0.5294,0.5961>*Back_Dc]}
       #else
        color_map{[0 rgb <0.4627,0.5294,0.5961>*Back_Dc][BackMap rgb<0.8471,0.9137,0.9804>*Back_Dc]}
       #end
       scale.5
       rotate x*90
       warp{turbulence BackTurb}
       rotate BackRotate}
 #break
 #case(11)  #declare Sky_Pigment=pigment{cylindrical
       #if(BackRev)
        color_map{[0 rgb<1.0000,1.0000,0.9863>*Back_Dc][BackMap rgb<0.8196,0.8196,0.6196>*Back_Dc]}
       #else
        color_map{[0 rgb<0.8196,0.8196,0.6196>*Back_Dc][BackMap rgb<1.0000,1.0000,0.9863>*Back_Dc]}
       #end
       warp{turbulence BackTurb}
       scale.5
       rotate x*90
       rotate BackRotate}
 #break

#else
   #declare Sky_Pigment=pigment{gradient y
       #if(BackRev)
        color_map{[0 rgb <0,0,0>*Back_Dc][BackMap rgb<1.0000,1.0000,1>*Back_Dc]}
       #else
        color_map{[0 rgb<1,1,1>*Back_Dc][BackMap rgb<0,0,0>*Back_Dc]}
       #end
       warp{repeat y flip y}
       warp{turbulence BackTurb}
       rotate BackRotate}     
#end

 #declare Boxc=0;//numnber of boxes
//#declare LRsky=union{0,1 pigment{Red}}
#declare LRClouds=union{
 #if(Bit(Boxn,0))
 #declare Boxc=Boxc+1;
 box{LBoxL,LBoxH
    pigment{gradient z 
           pigment_map{[CloudL_Range.x CL1 scale CloudLn_Ps/(Zscal-BoxD)]
                       [CloudL_Range.y CL2 scale CloudLf_Ps/(Zscal-BoxD)]}
           turbulence CloudL_Turb
           scale Zscal-BoxD }
    finish{ambient CloudL_Amb diffuse 0} 
    #if(CloudL_Shadow=0) no_shadow #end
    //double_illuminate 
    hollow}
 #end
 #if(Bit(Boxn,1))
 #declare Boxc=Boxc+1;
 box{BoxL,BoxH
    pigment{gradient z 
           pigment_map{[CloudM_Range.x CM1 scale CloudMn_Ps/Zscal]
                       [CloudM_Range.y CM2 scale CloudMf_Ps/Zscal]}
           turbulence CloudM_Turb
           scale Zscal}
    finish{ambient CloudM_Amb diffuse 0} 
    #if(CloudM_Shadow=0) no_shadow #end
    hollow}
 #end
 #if(Bit(Boxn,2))
 #declare Boxc=Boxc+1;
 box{HBoxL,HBoxH
    pigment{gradient z 
           pigment_map{[CloudH_Range.x CH1 scale CloudHn_Ps/(Zscal+BoxD)]
                       [CloudH_Range.y CH2 scale CloudHf_Ps/(Zscal+BoxD)]}
           turbulence CloudH_Turb
           scale Zscal+BoxD}
    finish{ambient CloudH_Amb diffuse 0}
    #if(CloudH_Shadow=0) no_shadow #end
    hollow}
 #end
}

//=========save tmp inc file===============
#if(strlen(SaveSky))
 #if(AddtoSky) #fopen Mfile SaveSky append 
  #debug concat("\n  Added Sky to ",SaveSky,"\n\n")
 #else #fopen Mfile SaveSky write
  #debug concat("\n  Saved Sky as ",SaveSky,"\n\n")
 #end
//find cloud used
 #if(Boxc)
   #if(Bit(Boxn,0)) 
    #if((CloudLn=CloudLf)& Vequ(CloudLn_Dc,CloudLf_Dc)& Vequ(CloudLn_Ps,CloudLf_Ps))
     #declare CL2p=CL1p   #declare CL2n=CL1n
     Cloud_Select(CloudLn,CL2p,CloudLn_Dc,CloudL_Mv,CloudL_Rot)
    #else 
     Cloud_Select(CloudLn,CL1p,CloudLn_Dc,CloudL_Mv,CloudL_Rot)
     Cloud_Select(CloudLf,CL2p,CloudLf_Dc,CloudL_Mv,CloudL_Rot)
    #end
   #end
   #if(Bit(Boxn,1)) 
    #if((CloudMn=CloudMf)& Vequ(CloudMn_Dc,CloudMf_Dc)& Vequ(CloudMn_Ps,CloudMf_Ps))
     #declare CM2p=CM1p #declare CM2n=CM1n
     Cloud_Select(CloudMn,CM2p,CloudMn_Dc,CloudM_Mv,CloudM_Rot)
    #else 
     Cloud_Select(CloudMn,CM1p,CloudMn_Dc,CloudM_Mv,CloudM_Rot)
     Cloud_Select(CloudMf,CM2p,CloudMf_Dc,CloudM_Mv,CloudM_Rot)
    #end
   #end
  #if(Bit(Boxn,2)) 
    #if((CloudHn=CloudHf)& Vequ(CloudHn_Dc,CloudHf_Dc)& Vequ(CloudHn_Ps,CloudHf_Ps))
     #declare CH2p=CH1p #declare CH2n=CH1n
     Cloud_Select(CloudHn,CH2p,CloudHn_Dc,CloudH_Mv,CloudH_Rot)
    #else 
     Cloud_Select(CloudHn,CH1p,CloudHn_Dc,CloudH_Mv,CloudH_Rot)
     Cloud_Select(CloudHf,CH2p,CloudHf_Dc,CloudH_Mv,CloudH_Rot)
    #end
   #end
 // place boxes with clouds
  #if(Boxc>1) #write (Mfile "#declare LRsky=union{\n")
  #else  #write (Mfile "#declare LRsky= \n")
  #end
  #if(Bit(Boxn,0))
   #write (Mfile "  box{",LBoxL,","LBoxH,"\n")
   #write (Mfile "     pigment{gradient z\n") 
   #write (Mfile "           pigment_map{[",CloudL_Range.x," ",CL1n," scale ",CloudLn_Ps/(Zscal-BoxD),"]\n")
   #write (Mfile "                       [",CloudL_Range.y," ",CL2n," scale ",CloudLf_Ps/(Zscal-BoxD),"]}\n")
   #write (Mfile "           turbulence",CloudL_Turb,"\n")
   #write (Mfile "           scale ",Zscal-BoxD,"}\n")
   #write (Mfile "    finish{ambient",CloudL_Amb," diffuse 0}\n")
   #if(CloudL_Shadow=0) #write (Mfile "    no_shadow\n") #end
   #write (Mfile "    hollow}\n")
  #end
  #if(Bit(Boxn,1))
   #write (Mfile "  box{",BoxL,","BoxH,"\n")
   #write (Mfile "     pigment{gradient z\n") 
   #write (Mfile "           pigment_map{[",CloudM_Range.x," ",CM1n," scale ",CloudMn_Ps/Zscal,"]\n")
   #write (Mfile "                       [",CloudM_Range.y," ",CM2n," scale ",CloudMf_Ps/Zscal,"]}\n")
   #write (Mfile "           turbulence",CloudM_Turb,"\n")
   #write (Mfile "           scale ",Zscal,"}\n")
   #write (Mfile "    finish{ambient",CloudM_Amb," diffuse 0}\n")
   #if(CloudM_Shadow=0) #write (Mfile "    no_shadow\n") #end
   #write (Mfile "    hollow}\n")
  #end
  #if(Bit(Boxn,2))
   #write (Mfile "  box{",HBoxL,","HBoxH,"\n")
   #write (Mfile "     pigment{gradient z\n") 
   #write (Mfile "           pigment_map{[",CloudH_Range.x," ",CH1n," scale ", CloudHn_Ps/(Zscal+BoxD),"]\n")
   #write (Mfile "                       [",CloudH_Range.y," ",CH2n," scale ", CloudHf_Ps/(Zscal+BoxD),"]}\n")
   #write (Mfile "           turbulence",CloudH_Turb,"\n")
   #write (Mfile "           scale ",Zscal+BoxD,"}\n")
   #write (Mfile "    finish{ambient",CloudL_Amb," diffuse 0}\n")
   #if(CloudH_Shadow=0) #write (Mfile "    no_shadow\n") #end
   #write (Mfile "    hollow}\n")
  #end
  #if(Boxc>1) #write (Mfile " }") #end
   #write (Mfile "\n\n")
   #write (Mfile "object{LRsky}\n\n")//show boxes
 #end 

// back ground sky 
 #switch(BackPig)
  #case(1) 
   #write (Mfile "sky_sphere{pigment{gradient y\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<0.1647,0.1980,0.7922>*Back_Dc,"][",BackMap," rgb",<0.9196,0.9608,1.0000>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<0.9196,0.9608,1.0000>*Back_Dc,"][",BackMap," rgb",<0.1647,0.1980,0.7922>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  warp{repeat y flip y}\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile " rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
  #break
  #case(2) 
   #write (Mfile "sky_sphere{pigment{gradient y\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<0.1647,0.4980,0.7922>*Back_Dc,"][",BackMap," rgb",<0.6196,0.9608,1.0000>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<0.6196,0.9608,1.0000>*Back_Dc,"][",BackMap," rgb",<0.1647,0.4980,0.7922>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  warp{repeat y flip y}\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile " rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
  #break
  #case(3)
   #write (Mfile "sky_sphere{pigment{gradient y\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<0.5647,0.1980,0.6922>*Back_Dc,"][",BackMap," rgb",<1,0.9008,1.0000>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<1,0.9008,1.0000>*Back_Dc,"][",BackMap," rgb",<0.5647,0.1980,0.6922>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  warp{repeat y flip y}\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile " rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
  #break
  #case(4)
   #write (Mfile "sky_sphere{pigment{gradient y\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<0.4627,0.5294,0.5961>*Back_Dc,"][",BackMap," rgb",<0.6471,0.7137,0.7804>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<0.6471,0.7137,0.7804>*Back_Dc,"][",BackMap," rgb",<0.4627,0.5294,0.5961>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  warp{repeat y flip y}\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile " rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
  #break
  #case(5)
   #write (Mfile "sky_sphere{pigment{gradient y\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<0.8196,0.8196,0.6196>*Back_Dc,"][",BackMap," rgb",<1.0000,1.0000,0.8863>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<1.0000,1.0000,0.8863>*Back_Dc,"][",BackMap," rgb",<0.8196,0.8196,0.6196>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  warp{repeat y flip y}\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile " rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
   #break
  #case(6) 
   #write (Mfile "sky_sphere{pigment{cylindrical\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<1,1,1>*Back_Dc,"][",BackMap," rgb",<0,0,0>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<0,0,0>*Back_Dc,"][",BackMap," rgb",<1,1,1>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  scale .5\n")
    #write (Mfile "  rotate x*90\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile "  rotate ",BackRotate,"}\n")#end
    #write (Mfile " }\n")
   #break
  #case(7) 
   #write (Mfile "sky_sphere{pigment{cylindrical\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<0.9196,0.9608,1.0000>*Back_Dc,"][",BackMap," rgb",<0.1647,0.1980,0.7922>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<0.1647,0.1980,0.7922>*Back_Dc,"][",BackMap," rgb",<0.9196,0.9608,1.0000>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  scale .5\n")
    #write (Mfile "  rotate x*90\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile "  rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
  #break
  #case(8) 
   #write (Mfile "sky_sphere{pigment{cylindrical\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rbg",<0.6196,0.9608,1.0000>*Back_Dc,"][",BackMap," rgb",<0.1647,0.4980,0.7922>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<0.1647,0.4980,0.7922>*Back_Dc,"][",BackMap," rgb",<0.6196,0.9608,1.0000>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  scale .5\n")
    #write (Mfile "  rotate x*90\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile "  rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
  #break
  #case(9)
   #write (Mfile "sky_sphere{pigment{cylindrical\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<1,0.9008,1.0000>*Back_Dc,"][",BackMap," rgb",<0.5647,0.1980,0.6922>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<0.5647,0.1980,0.6922>*Back_Dc,"][",BackMap," rgb",<1,0.9008,1.0000>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  scale .5\n")
    #write (Mfile "  rotate x*90\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile "  rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
  #break
  #case(10)
   #write (Mfile "sky_sphere{pigment{cylindrical\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<0.8471,0.9137,0.9804>*Back_Dc,"][",BackMap," rgb",<0.4627,0.5294,0.5961>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<0.4627,0.5294,0.5961>*Back_Dc,"][",BackMap," rgb",<0.8471,0.9137,0.9804>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  scale .5\n")
    #write (Mfile "  rotate x*90\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile "  rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
  #break
  #case(11)
   #write (Mfile "sky_sphere{pigment{cylindrical\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<1.0000,1.0000,0.9863>*Back_Dc,"][",BackMap," rgb",<0.8196,0.8196,0.6196>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<0.8196,0.8196,0.6196>*Back_Dc,"][",BackMap," rgb",<1.0000,1.0000,0.9863>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  scale .5\n")
    #write (Mfile "  rotate x*90\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile " rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
   #break
  #else
   #write (Mfile "sky_sphere{pigment{gradient y\n")
   #if(BackRev)
    #write (Mfile "  color_map{[0 rgb",<0,0,0>*Back_Dc,"][",BackMap," rgb",<1,1,1>*Back_Dc,"]}\n")
   #else
    #write (Mfile "  color_map{[0 rgb",<1,1,1>*Back_Dc,"][",BackMap," rgb",<0,0,0>*Back_Dc,"]}\n")
   #end
    #write (Mfile "  warp{repeat y flip y}\n")
    #if(vlength(BackTurb))#write (Mfile "  warp{turbulence",BackTurb,"}\n")#end
    #if(vlength(BackRotate))#write (Mfile " rotate ",BackRotate,"\n")#end
    #write (Mfile " }}\n")
  #end
    #write (Mfile "\n//______Perview camera_______\n")
    #write (Mfile " camera{ location <0,0,0>\n")
    #write (Mfile "         look_at <0,0,1>\n")
    #write (Mfile "         right x*image_width/image_height\n")
    #write (Mfile "       }\n")
   #fclose Mfile 
#end 
 
//=========== test sky ==============================
#ifndef(Get)

 global_settings {max_trace_level 20}

 camera{location <0,0,0>
        look_at <0,0,1>
        right x*image_width/image_height
        }
 light_source{<0,900,500> color rgb 1 parallel point_at<0,0,0>}

 object{LRClouds}
 sky_sphere{pigment{Sky_Pigment}}

 /*/ground
 plane{y,-10 
       //pigment{crackle pigment_map {[0 rgb 0][1/20 rgb<1.0000,0.7961,0.6275>]}scale 20}
       pigment{rgb<0.4627,0.5294,0.5961>}//rgb<1.0000,0.7961,0.6275>}
       normal{bozo scale 2}// granite 
      }
  */
 //box{<-25999,-400,-99>,<25999,-490,20000> pigment{rgb<.2,.4,.5>}}

 /*/sun
 sphere{0,100 pigment{rgb<1,1,.8>} 
       finish{ambient 1 diffuse 0}
       translate z*5000 rotate BackRotate}
 */
#end   